#include "char_mouse.h"
#include "timer_hooks.h"
#include <conio.h>

unsigned int screen_offsets[25]=
{
  0*40, 1*40, 2*40, 3*40, 4*40, 5*40, 6*40, 7*40, 8*40,
  9*40, 10*40, 11*40, 12*40, 13*40, 14*40, 15*40, 16*40,
  17*40, 18*40, 19*40, 20*40, 21*40, 22*40, 23*40, 24*40
};

unsigned char mtab[16]=
{
//255 (bit 7 on) means do nothing
//0 means increment
//1 means decrement
//X is OLD|NEW
//Y is NEW|OLD
0xFF,         //index 00 ( 0000 ) old 0 new 0 no change
0x01,         //index 01 ( 0001 ) old 0 new 1 ??decrement
0x00,         //index 02 ( 0010 ) old 0 new 2 increment
0x01,         //index 03 ( 0011 ) old 0 new 3 increment
0x00,         //index 04 ( 0100 ) old 1 new 0 decrement
0xFF,         //index 05 ( 0101 ) old 1 new 1 no change
0x00,         //index 06 ( 0110 ) old 1 new 2 increment
0x01,         //index 07 ( 0111 ) old 1 new 3 ??decrement 
0x01,         //index 08 ( 1000 ) old 2 new 0 decrement
0x00,         //index 09 ( 1001 ) old 2 new 1 ??increment
0xFF,         //index 10 ( 1010 ) old 2 new 2 no change
0x00,         //index 11 ( 1011 ) old 2 new 3 increment 
0x01,         //index 12 ( 1100 ) old 3 new 0 decrement
0x00,         //index 13 ( 1101 ) old 3 new 1 increment
0x01,         //index 14 ( 1110 ) old 3 new 2 decrement
0xFF          //index 15 ( 1111 ) old 3 new 3 no change
};

static BYTE mouse_b=0;
static BYTE dumx=0xC0;
static BYTE dumy=0x03;
static BYTE tmp1=0;
static BYTE tmp2=0;

static BYTE mouse_x=0;
static BYTE mouse_y=0;

static BYTE mchar =128;
static BYTE under;
static BYTE hidden=0;
static BYTE flag=0xff;
static BYTE *screen_ptr=0;

static unsigned char inc=0;

void (*unhook)(unsigned char timer, unsigned int oldvector );
static unsigned int oldvec;
static BYTE hooked;

static unsigned char max_x=39+1;
static unsigned char max_y=23+1;
static unsigned char min_x=0-1;
static unsigned char min_y=0-1;

#define STRIG0 0x0284
#define STRIG1 0x0285
static BYTE *mouse_port=STRIG0;

void update_mouse    ( void );

void init_mouse      ( BYTE cursor_char, 
                       BYTE port,
		       BYTE hook )
{
  //get screen base
  screen_ptr=*((unsigned int *)88);

  //save character for redraw
  under=*screen_ptr;
  //set cursor information
  mchar=cursor_char;

  //save port
  if ( port == 0 )
    mouse_port=STRIG0;
  else
    mouse_port=STRIG1;

  hook_timer(hook,1,0,100,update_mouse,&oldvec); // 15000/100=150 times per second 
  unhook=unhook_timer;
  hooked=hook;
}

void set_mouse_cursor(unsigned char cursor_shape)
{
  mchar=cursor_shape;
}

void set_mouse_limits(unsigned char minrow,
                      unsigned char mincol,
                      unsigned char maxrow,
                      unsigned char maxcol)
{
  mouse_x=mincol;
  mouse_y=minrow;
  max_x=maxcol+1;
  max_y=maxrow+1;
  min_x=mincol-1;
  min_y=minrow-1;
}

unsigned char mval=0;

void read_mouse( void )
{
  mouse_b=(unsigned char)0;
  if ( *mouse_port == 0 )
    mouse_b=(unsigned char)1;
}

static unsigned char portval;
static unsigned char action;

void update_mouse( void )
{
  portval=*(unsigned char *)0xD300;  //read port
  flag=0;                            //assert that we did nothing

  //process X value
  tmp1=portval & 0x03;               //mask off unwanted bits
  tmp1 |= dumx;                      //or in old X value
  action=mtab[tmp1];                 //get action
  if ( action != 0xFF )              //if action is 255, nothing to do
  {
    flag=1;                          //mark redraw needed
    if ( action == 1)                //for x, 1 means decrement
      --mouse_x;
    else                             //and 0 means increament
      ++mouse_x;
    if ( mouse_x == max_x )
      --mouse_x; 
    if ( mouse_x == min_x )
      ++mouse_x;
    tmp1=tmp1 & 0x03;
    dumx=tmp1 << 2;
  }

  //process y value
  tmp1=portval & 0x0C;               //mask off unwanted bits
  tmp1 |= dumy;                      //or in old Y value
  action=mtab[tmp1];                 //get action
  if ( action != 0xFF )              //if its 255, nothing to do
  {
    flag=1;                          //mark redraw needed
    if ( action == 1)                //for y, 1 means increment
      ++mouse_y;
    else                             //and 0 means decrement
      --mouse_y;
    if ( mouse_y == max_y )
      --mouse_y; 
    if ( mouse_y == min_y )
      ++mouse_y;
    tmp1=tmp1 & 0x0C;
    dumy=tmp1 >> 2;
  }

  if ( flag )   //if we have something to do
  {
    *(unsigned char *)0x4D=0;
    if ( hidden==0 )
    {
      *screen_ptr=under;
      //move screen_ptr to new location
      screen_ptr=*((unsigned int *)88);
      screen_ptr+=screen_offsets[mouse_y];
      screen_ptr+=mouse_x;
      //save new under
      under=*screen_ptr;
      //draw new cursor
      if ( mchar == 255 )
      {
        *screen_ptr=(under | 0x80);
      }else{
        *screen_ptr=mchar;
      }
    }
  }
}

void hide_mouse       ( void )
{
  if ( !hidden )
  {
    hidden=1;
    //put old char back
    *screen_ptr=under;
  }
}

void show_mouse       ( void )
{
    hidden=0;
}

void terminate_mouse  ( void )
{
  hide_mouse();
  unhook(hooked,oldvec);
}




