//Hook for timer 1
#ifndef _CHAR_MOUSE_HFILE
#define _CHAR_MOUSE_HFILE

#ifndef BYTE_DEF
  #define BYTE  unsigned char
  #define SBYTE static unsigned char
  #define BYTE_DEF
#endif

//these must match the timer_x defines in timer_hooks.h
#define HOOK_TIMER1 0  
#define HOOK_TIMER2 1  
#define HOOK_TIMER4 2  
//these do not, they are currently not implemented
#define HOOK_VBI    4  
#define HOOK_VBD    5  

//Initialize mouse library
//  cursor_char : ATASCII code of character to use as cursor 
//                or 255 for bit-7 toggle ( inverse )
//  port        : 0 - joystick 0
//                1 - joystick 1
//  hook        : see #defines for HOOK_XXXX
void init_mouse      ( BYTE cursor_char, 
                       BYTE port,
		       BYTE hook );

void set_mouse_cursor( BYTE cursor_char );

void set_mouse_limits(unsigned char minrow,
                      unsigned char mincol,
                      unsigned char maxrow,
                      unsigned char maxcol);
                      
void read_mouse( void );

void update_mouse     ( void );
void hide_mouse       ( void );
void show_mouse       ( void );
void terminate_mouse  ( void );

extern unsigned char mouse_x;
extern unsigned char mouse_y;
extern unsigned char mouse_b;

#endif

