#include "timer_hooks.h"

timer_task timer_vector;

unsigned char *screen_ptr;
unsigned char inc;

#pragma optimize(push,off)
void timer_wrapper( void )
{
  PUSH_REGS;
  
  //this method of call destroys ptr1, so needs saving
  //it is the responsibility of the interrupt code to 
  //preserve any other CC65 ZP vars it may or may not use
  asm("lda ptr1");
  asm("pha");
  asm("lda ptr1+1");
  asm("pha");
  asm("lda tmp1");
  asm("pha");
  asm("lda sreg");
  asm("pha");
  asm("lda sreg+1");
  asm("pha");
  

  timer_vector();

  asm("pla");
  asm("sta sreg+1");
  asm("pla");
  asm("sta sreg");
  asm("pla");
  asm("sta tmp1");
  asm("pla");
  asm("sta ptr1+1");
  asm("pla");
  asm("sta ptr1");

  PULL_REGS;
  
  asm("pla");
  asm("rti");
}
#pragma optimize(pop)

unsigned char  enablemasks[3]   ={1,2,4};
#define ENABLE_CPU_INTERRUPTS  asm("cli")
#define DISABLE_CPU_INTERRUPTS asm("sei")
static unsigned char tmp;

//this routine is a bit unrolled in terms of duplicated code
//it compiles better with -Osir if I leave in a little duplication
void hook_timer(  unsigned char timer,         //which timer ( 0=1,1=2,3=4 )
                  unsigned char audctl,        //control values
                  unsigned char audc,   
                  unsigned char audf,   
                  timer_task task,             //timer routine
		  unsigned int *oldvector )    //previous timer routine
{
  timer_vector=task;
  switch( timer )
  {
    case 0:   //timer 1
    {
      *oldvector=*((unsigned int *)0x210);
      *((unsigned int *)0x210)=(unsigned int)timer_wrapper;
      *(unsigned char *)0xD201=audc;
      *(unsigned char *)0xD200=audf;
      break;
    }
    case 1:   //timer 2
    {
      *oldvector=*((unsigned int *)0x212);
      *((unsigned int *)0x212)=(unsigned int)timer_wrapper;
      *(unsigned char *)0xD203=audc;
      *(unsigned char *)0xD202=audf;
      break;
    }
    case 2:   //timer 4
    {
      *oldvector=*((unsigned int *)0x214);
      *((unsigned int *)0x214)=(unsigned int)timer_wrapper;
      *(unsigned char *)0xD207=audc;
      *(unsigned char *)0xD206=audf;
      break;
    }
  }
  *(AUDCTL)=audctl;
  DISABLE_CPU_INTERRUPTS;
  tmp=(*POKMSK) | enablemasks[timer];
  *POKMSK=tmp;
  *IRQEN =tmp;
  *STIMER=tmp;
  ENABLE_CPU_INTERRUPTS;
}

void unhook_timer( unsigned char timer, unsigned int oldvector )
{
  unsigned char tmp;
  DISABLE_CPU_INTERRUPTS;
  tmp=*POKMSK & ~enablemasks[timer];
  *POKMSK=tmp;
  *IRQEN =tmp;
  switch( timer )
  {
    case 0:   //timer 1
    {
      *((unsigned int *)0x210)=(unsigned int)oldvector;
      break;
    }
    case 1:   //timer 2
    {
      *((unsigned int *)0x212)=(unsigned int)oldvector;
      break;
    }
    case 2:   //timer 4
    {
      *((unsigned int *)0x214)=(unsigned int)oldvector;
      break;
    }
  }
  ENABLE_CPU_INTERRUPTS;
}



