//Hook for timers
#ifndef _TIMER_HOOKS_HFILE
#define _TIMER_HOOKS_HFILE

#define AUDCTL (unsigned char *)(0xD208)
#define STIMER (unsigned char *)(0xD209)
#define POKMSK (unsigned char *)(0x10  )
#define IRQEN  (unsigned char *)(0xD20E)
#define ENABLE_CPU_INTERRUPTS  asm("cli")
#define DISABLE_CPU_INTERRUPTS asm("sei")
#define PUSH_REGS   asm("pha"); asm("tya"); asm("pha"); asm("txa"); asm("pha");
#define PULL_REGS   asm("pla"); asm("tax"); asm("pla"); asm("tay"); asm("pla");
 
  #define TIMER_1 0
  #define TIMER_2 1
  #define TIMER_4 2

  typedef void (*timer_task)(void);

  void hook_timer(  unsigned char timer,         //which timer ( 0=1,1=2,3=4 )
                    unsigned char audctl,        //control values
                    unsigned char audc,   
                    unsigned char audf,   
                    timer_task task,             //timer routine
		    unsigned int *oldvector );   //previous timer routine

   void unhook_timer( unsigned char timer, unsigned int oldvector );

#endif

